/* This is "rod3.c", written to accompany Introduction to
   Scientific Programming by Joseph L. Zachary. */

/* This program is an implementation and driver for the
   "distance" function described in Chapter 13 of the text. */


#include <math.h>
#include <stdio.h>



/* Returns the square of "x". */

double sq (double x)
{
  return(x*x);
}



/* Given the lengths of three sides of a triangle, returns
   the cosine of the angle between the first two. */

double cosine (double adj1, double adj2, double opp)
{
  return((sq(adj1) + sq(adj2) - sq(opp)) / (2*adj1*adj2));
}



/* Returns the distance between the points (x1,y1)
   and (x2,y2). */

double distance (double x1, double y1,
                 double x2, double y2)
{
  return(sqrt(sq(x1-x2) + sq(y1-y2)));
}



/* A test driver for "distance". */

void main (void)
{
  double x1, y1, x2, y2;
  printf("Enter a point (two doubles): ");
  scanf("%lf%lf", &x1, &y1);
  printf("Enter another point (two doubles): ");
  scanf("%lf%lf", &x2, &y2);
  printf("distance(%g, %g, %g, %g) = %g\n",
         x1, y1, x2, y2, distance(x1, y1, x2, y2));
}
